# WARNING: Please don't edit this file. It was generated by Python/WinRT v1.0.0-beta.4

import enum
import sys
import types
import typing
import uuid

import winsdk._winrt as _winrt

try:
    import winsdk.windows.foundation
except Exception:
    pass

try:
    import winsdk.windows.foundation.collections
except Exception:
    pass

try:
    import winsdk.windows.ui
except Exception:
    pass

class CoreInputViewKind(enum.IntEnum):
    DEFAULT = 0
    KEYBOARD = 1
    HANDWRITING = 2
    EMOJI = 3
    SYMBOLS = 4
    CLIPBOARD = 5
    DICTATION = 6

class CoreInputViewOcclusionKind(enum.IntEnum):
    DOCKED = 0
    FLOATING = 1
    OVERLAY = 2

class CoreInputViewXYFocusTransferDirection(enum.IntEnum):
    UP = 0
    RIGHT = 1
    DOWN = 2
    LEFT = 3

class CoreFrameworkInputView(_winrt.Object, interfaces=[]):
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreFrameworkInputView: ...
    @staticmethod
    def get_for_current_view() -> typing.Optional[CoreFrameworkInputView]: ...
    @staticmethod
    def get_for_u_i_context(context: typing.Optional[winsdk.windows.ui.UIContext]) -> typing.Optional[CoreFrameworkInputView]: ...
    def add_occlusions_changed(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreFrameworkInputView, CoreFrameworkInputViewOcclusionsChangedEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_occlusions_changed(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_primary_view_animation_starting(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreFrameworkInputView, CoreFrameworkInputViewAnimationStartingEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_primary_view_animation_starting(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...

class CoreFrameworkInputViewAnimationStartingEventArgs(_winrt.Object, interfaces=[]):
    animation_duration: winsdk.windows.foundation.TimeSpan
    framework_animation_recommended: _winrt.Boolean
    occlusions: typing.Optional[winsdk.windows.foundation.collections.IVectorView[CoreInputViewOcclusion]]
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreFrameworkInputViewAnimationStartingEventArgs: ...

class CoreFrameworkInputViewOcclusionsChangedEventArgs(_winrt.Object, interfaces=[]):
    handled: _winrt.Boolean
    occlusions: typing.Optional[winsdk.windows.foundation.collections.IVectorView[CoreInputViewOcclusion]]
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreFrameworkInputViewOcclusionsChangedEventArgs: ...

class CoreInputView(_winrt.Object, interfaces=[]):
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputView: ...
    def get_core_input_view_occlusions(self) -> typing.Optional[winsdk.windows.foundation.collections.IVectorView[CoreInputViewOcclusion]]: ...
    @staticmethod
    def get_for_current_view() -> typing.Optional[CoreInputView]: ...
    @staticmethod
    def get_for_u_i_context(context: typing.Optional[winsdk.windows.ui.UIContext]) -> typing.Optional[CoreInputView]: ...
    def is_kind_supported(self, type: CoreInputViewKind) -> _winrt.Boolean: ...
    def try_hide(self) -> _winrt.Boolean: ...
    def try_hide_primary_view(self) -> _winrt.Boolean: ...
    @typing.overload
    def try_show(self) -> _winrt.Boolean: ...
    @typing.overload
    def try_show(self, type: CoreInputViewKind) -> _winrt.Boolean: ...
    def try_show_primary_view(self) -> _winrt.Boolean: ...
    def try_transfer_x_y_focus_to_primary_view(self, origin: winsdk.windows.foundation.Rect, direction: CoreInputViewXYFocusTransferDirection) -> _winrt.Boolean: ...
    def add_occlusions_changed(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, CoreInputViewOcclusionsChangedEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_occlusions_changed(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_x_y_focus_transferred_to_primary_view(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, _winrt.Object]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_x_y_focus_transferred_to_primary_view(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_x_y_focus_transferring_from_primary_view(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, CoreInputViewTransferringXYFocusEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_x_y_focus_transferring_from_primary_view(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_primary_view_hiding(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, CoreInputViewHidingEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_primary_view_hiding(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_primary_view_showing(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, CoreInputViewShowingEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_primary_view_showing(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_primary_view_animation_starting(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, CoreInputViewAnimationStartingEventArgs]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_primary_view_animation_starting(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...
    def add_supported_kinds_changed(self, handler: winsdk.windows.foundation.TypedEventHandler[CoreInputView, _winrt.Object]) -> winsdk.windows.foundation.EventRegistrationToken: ...
    def remove_supported_kinds_changed(self, token: winsdk.windows.foundation.EventRegistrationToken) -> None: ...

class CoreInputViewAnimationStartingEventArgs(_winrt.Object, interfaces=[]):
    handled: _winrt.Boolean
    animation_duration: winsdk.windows.foundation.TimeSpan
    occlusions: typing.Optional[winsdk.windows.foundation.collections.IVectorView[CoreInputViewOcclusion]]
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputViewAnimationStartingEventArgs: ...

class CoreInputViewHidingEventArgs(_winrt.Object, interfaces=[]):
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputViewHidingEventArgs: ...
    def try_cancel(self) -> _winrt.Boolean: ...

class CoreInputViewOcclusion(_winrt.Object, interfaces=[]):
    occluding_rect: winsdk.windows.foundation.Rect
    occlusion_kind: CoreInputViewOcclusionKind
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputViewOcclusion: ...

class CoreInputViewOcclusionsChangedEventArgs(_winrt.Object, interfaces=[]):
    handled: _winrt.Boolean
    occlusions: typing.Optional[winsdk.windows.foundation.collections.IVectorView[CoreInputViewOcclusion]]
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputViewOcclusionsChangedEventArgs: ...

class CoreInputViewShowingEventArgs(_winrt.Object, interfaces=[]):
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputViewShowingEventArgs: ...
    def try_cancel(self) -> _winrt.Boolean: ...

class CoreInputViewTransferringXYFocusEventArgs(_winrt.Object, interfaces=[]):
    transfer_handled: _winrt.Boolean
    keep_primary_view_visible: _winrt.Boolean
    direction: CoreInputViewXYFocusTransferDirection
    origin: winsdk.windows.foundation.Rect
    @staticmethod
    def _from(obj: _winrt.Object) -> CoreInputViewTransferringXYFocusEventArgs: ...

class UISettingsController(_winrt.Object, interfaces=[]):
    @staticmethod
    def _from(obj: _winrt.Object) -> UISettingsController: ...
    @staticmethod
    def request_default_async() -> winsdk.windows.foundation.IAsyncOperation[UISettingsController]: ...
    def set_advanced_effects_enabled(self, value: _winrt.Boolean) -> None: ...
    def set_animations_enabled(self, value: _winrt.Boolean) -> None: ...
    def set_auto_hide_scroll_bars(self, value: _winrt.Boolean) -> None: ...
    def set_message_duration(self, value: _winrt.UInt32) -> None: ...
    def set_text_scale_factor(self, value: _winrt.Double) -> None: ...

